Name:           FSMDesigner4
Version:        1.2
Release:        1%{?dist}
Summary:        A Finite State Machine design tool

Group:          Applications/Engineering
License:        GPLv2+
URL:            http://sourceforge.net/projects/fsmdesigner/
Source0:        http://downloads.sourceforge.net/fsmdesigner/%{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch0:         FSMDesigner4-1.2-save.patch

BuildRequires:  swig
BuildRequires:  qt4-devel
BuildRequires:  xerces-c-devel
BuildRequires:  python-devel
BuildRequires:  pkgconfig
BuildRequires:  desktop-file-utils
BuildRequires:  mlocate

Requires:       electronics-menu

# menu entry icon, since %%{name} doesn't ship one
Requires:       oxygen-icon-theme


%description
FSMDesigner4 is a C++ based implementation for
a Finite State Machine (FSM) design tool with
integrated Hardware Description Language (HDL)
generation. FSMDesigner4 uses the Simple-Moore
FSM model guaranteeing efficient fast complex
control circuits.

%prep
%setup -q

# desktop file
cat > %{name}.desktop <<EOF
[Desktop Entry]
Categories=Electronics;
Comment=A Finite State Machine design tool
Encoding=UTF-8
Exec=fsmdesigner4
GenericName=Finite State Machine design tool
Icon=okteta
Name=State Machine design tool
Terminal=false
Type=Application
EOF


#error: 'strcmp' was not declared in this scope
%{__sed} -i "s|#include <string>|#include <cstring>|" \
    src/xmlcreate/xmlsave.cpp

#error: 'exit' was not declared in this scope
%{__sed} -i "s|#include <iostream>|#include <iostream>\n#include <cstdlib>|" \
    src/verification/main.cpp

#error: invalid use of incomplete type 'const struct xercesc_2_8::Attributes'
%{__sed} -i \
"s|#include\"xmlread.h\"|#include\"xmlread.h\"\n#include <xercesc/sax2/Attributes.hpp>|" \
    src/genvhdl/xmlread.cpp

# E: only-non-binary-in-usr-lib
%{__sed} -i "s|pythondir = \$(libdir)|pythondir = \$(libdir)/%{name}|" \
    src/python/Makefile*

# fixing save dialog box
%patch0 -p0 -b .save


%build

# as per Kevin_Kofler's advice
export PATH=%{_libdir}/qt4/bin:$PATH

%configure
%{__make} %{?_smp_mflags}


%install
%{__rm} -rf %{buildroot}
%{__make} install                \
    DESTDIR=%{buildroot}         \
    INSTALL="%{__install} -c -p" \
    CP="%{__cp} -p"


desktop-file-install                           \
    --dir %{buildroot}%{_datadir}/applications \
    %{name}.desktop


%clean
%{__rm} -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING
%{_bindir}/fsmdesigner4
%{_bindir}/createf4tbar
%{_bindir}/createmmap
%{_bindir}/createtestbench
%{_bindir}/dnfinvert
%{_bindir}/fsmmin
%{_bindir}/fsmverification
%{_bindir}/fsmveriloggeneration
%{_bindir}/fsmvhdlgeneration
%{_libdir}/%{name}/fsmdesigner.py*
%{_datadir}/applications/FSMDesigner4.desktop


%changelog
* Sat Dec 06 2008 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 1.2-1
- Initial package for fedora